#!/usr/bin/env python3
from unittest import TestCase

from ajgu.elements import Properties


class MockElement:

    def _dirty(self):
        pass


class TestElementProperties(TestCase):

    def test_diff(self):
        properties = Properties(dict(spam='egg'), MockElement())
        properties['spam'] = 'foobar'
        self.assertEqual(dict(spam=('foobar', 'egg')), properties.diff())

    def test_diff_two(self):
        properties = Properties(dict(), MockElement())
        properties['spam'] = 'foobar'
        self.assertEqual(dict(spam=('foobar', None)), properties.diff())

    def test_diff_three(self):
        properties = Properties(dict(spam='egg'), MockElement())
        self.assertEqual(dict(spam=(None, 'egg')), properties.diff())
